/* Модели понимания - функции

 */
package psychic

////////////////////////////////////////////////////



/* поиск решения по Моделям понимания
Использовать модели объектов для нахождения действий ПО АНАЛОГИИ с теми действиями,
что были в эпиз.памяти для данного объекта.
Леонардо да Винчи смотрел на штукатурку чтобы в голову пришла идея.

При удачном поиске будет создан и запущен автоматизм.
 */
func tryModelsLevel(c *cycleInfo)bool{

	actBest,_:=bestActionFromExtremImportanceObject()
	if actBest!=nil{// найдено лучшее
		//получить пользу из эффекта лучшего моторного действия: будет найден и запущен лучший мот.автоматизм aBest.ID
		return getBenefitFromEpizosMemory(c,actBest)
	}
	return false
}
//////////////////////////////////////////////////

/* найти лучший образ действий из extremImportanceObject

 */
func bestActionFromExtremImportanceObject()(*ActionsImage,int){
	if extremImportanceObject==nil{
		return nil,0
	}
	getRulesModelExactly(extremImportanceObject.objID)
	if UnderstandingRulesModel == nil{
		getRulesModelApproximately(extremImportanceObject.objID)
	}
	if UnderstandingRulesModel == nil{
		return nil,0
	}
	///////////
	var effectMax=0
	var actBest *ActionsImage

	for i := 0; i < len(UnderstandingRulesModel); i++ {
		rm:=UnderstandingRulesModel[i]
		if rm.Effect > effectMax{
			//actBest=ActionsImageArr[rm.Action] // ответ с хорошим эффектом
			actN,ok:=ReadeActionsImageArr(rm.Action)
			if !ok {
				continue
			}
			effectMax = rm.Effect
			actBest=actN // ответ с хорошим эффектом
		}
	}
	return actBest,effectMax
}
///////////////////////////////////////////////////////////

/* выбрать все позитивные образы действий из extremImportanceObject

 */
type bestActionArr struct {
	action *ActionsImage
	effect int
}
func bestActionArrFromExtremImportanceObject()[]bestActionArr{
	if extremImportanceObject==nil{
		return nil
	}
	getRulesModelExactly(extremImportanceObject.objID)
	if UnderstandingRulesModel == nil{
		getRulesModelApproximately(extremImportanceObject.objID)
	}
	if UnderstandingRulesModel == nil{
		return nil
	}
	///////////
	var out []bestActionArr

	for i := 0; i < len(UnderstandingRulesModel); i++ {
		rm:=UnderstandingRulesModel[i]
		if rm.Effect > 0{
			//actBest=ActionsImageArr[rm.Action] // ответ с хорошим эффектом
			actN,ok:=ReadeActionsImageArr(rm.Action)
			if !ok {
				continue
			}
			out=append(out,bestActionArr{actN, rm.Effect})// ответ с хорошим эффектом
		}
	}
	return out
}
///////////////////////////////////////////////////////////




/*попробовать для случая негативного obj *extremImportance или emExtrem *EpisodeMemory
Из нескольких акций
собрать один образ действий типа ActionsImage - из составляющих элементов с позитивными эффектами цепочки Правил
*/
func createSintezActiveActionsFromExtremImportanceObject()(ActionsImage,bool) {
	var action ActionsImage
	aArr := bestActionArrFromExtremImportanceObject()
	if aArr == nil {
		return action,false
	}
	aCount := len(aArr)
	if aCount == 1 {
		return *aArr[0].action,true
	}
	/* собрать образ действий типа ActionsImage.ID из составляющих элементов,
	вытаскивая из всех образов составляющие и выбирая из лучших один сложный образ действия.
	*/
	beast := 0
	toneID := 0
	moodID := 0

	for i := 0; i < aCount; i++ {
		for j := 0; j < len(aArr[i].action.ActID); j++ {
			action.ActID = append(action.ActID, aArr[i].action.ActID[j])
		}
		for j := 0; j < len(aArr[i].action.ActID); j++ {
			if aArr[i].action.PhraseID !=nil {
				action.PhraseID = append(action.PhraseID, aArr[i].action.PhraseID[j])
			}
		}
		if aArr[i].effect > beast {
			beast = aArr[i].effect
			toneID = aArr[i].action.ToneID
			moodID = aArr[i].action.MoodID
		}
	}
	action.ToneID = toneID
	action.MoodID = moodID

	return action,true
}
////////////////////////////////////////////////////////////////////



/*получить пользу из эффекта лучшего моторного действия
будет найден и запущен лучший мот.автоматизм aBest.ID
mentalInfoStruct.motorAtmzmID=aBest.ID
infoFunc17()// запустить автоматизм и завершить цикл осмысления
 */
func getBenefitFromEpizosMemory(c *cycleInfo,actBest *ActionsImage)bool{
if detectedActiveLastNodID==0{// так не должно быть..
	return false
}
// может быть несколько автоматизмов с одним и тем же действием, но с разными BranchID веками дерева автоматизмов или вообще не привязанные
	var eMax=0
	var aBest *Automatizm

	//штатный автоматизм активного узла дерева
	sA:=AutomatizmBelief2FromTreeNodeId[detectedActiveLastNodID]
	if sA!=nil{
		if sA.ActionsImageID == actBest.ID{
			// как раз штатный автоматизм и делает это
			mentalInfoStruct.motorAtmzmID=sA.ID
			infoFunc17(c)// запустить автоматизм и завершить цикл осмысления
			return true
		}
	}

	//найти мот.автоматизмы с таким действием и сравинить со штатным автоматизмом активного узла detectedActiveLastNodID

	for _, v := range AutomatizmFromId {
	if v==nil{continue}
		if v.ActionsImageID != actBest.ID || v.Usefulness<=0{
			continue
		}
		if eMax < v.Usefulness{
			eMax = v.Usefulness
			aBest=v
		}
	}

	if aBest!=nil{
		mentalInfoStruct.motorAtmzmID=aBest.ID
		infoFunc17(c)// запустить автоматизм и завершить цикл осмысления
		return true
	}else{// нет мот.автоматизм в конечном звене цикла, создать такой по действию actBest.ID
		//в infoFunc2() -> infoFunc7() -> infoFunc17()
		mentalInfoStruct.toAutmtzmActionsImageID=actBest.ID
	}

	return false
}
////////////////////////////////////////////



/* посмотреть максимальный эффект в Модели понимания
для данного образа действия типа ActionsImage
в данных условиях дерева проблем.
*/
func getExtremEffectFromModel(actImgID int)int{
	if actImgID==0 || detectedActiveLastProblemNodID==0{
		return 0
	}

	getRulesModelFromActionExactly(actImgID)
	if UnderstandingRulesModel == nil{
		return 0
	}
	///////////
	var effectMax=0

	for i := 0; i < len(UnderstandingRulesModel); i++ {
		rm:=UnderstandingRulesModel[i]
		if rm.Effect > effectMax{
			effectMax = rm.Effect
		}
	}
	if effectMax!=0{// найдено лучшее
		return effectMax
	}
	return 0
}
/////////////////////////////////////////////////////////////////


/* плохой ли выбор actionsImageID для мовершения действий
true - не подходящий для данного detectedActiveLastProblemNodID

Проверка только для tryModelsLevel_1() с точным результатом
*/
func isBadActionsImagefromTryActionArr(actImgID int)bool{
	getRulesModelFromActionExactly(actImgID)
	if UnderstandingRulesModel == nil{
		return false // если нет еще опыта, будем считать, что пойдет
	}
	///////////
	for i := 0; i < len(UnderstandingRulesModel); i++ {
		rm:=UnderstandingRulesModel[i]
		if rm.Effect < 0{
			return true
		}
	}
// если нет плохого эффекта, будем считать, что пойдет
	return false
}
///////////////////////////////////////////


/* посмотреть, насколько опасны последствия в Модели понимания
для данного образа действия типа ActionsImage
в данных условиях дерева проблем.
*/
func isDangerousModelAutomatism(actImgID int)int{
	if detectedActiveLastProblemNodID==0{
		return 0
	}

	getRulesModelFromActionExactly(actImgID)
	if UnderstandingRulesModel == nil{
		return 0
	}
	///////////
	var effectMin=0

	for i := 0; i < len(UnderstandingRulesModel); i++ {
		rm:=UnderstandingRulesModel[i]
		if rm.Effect < effectMin{
			effectMin = rm.Effect
		}
	}
/*так как эффект отрицательный потому, что негативный, переводим его в значение по модулю,
чтобы потом сравнивать не плохой с хорошим, а определять позитивный эфеект, ПРЕВЫШАЮЩИЙ негативный
только в этом случае стоит бездумно отдавать ему предпочтение, но только в прогнозе на 1 шаг:
разрешить сделать шаг назад, если потом СРАЗУ ЖЕ будет 2 шага вперед
более сложный анализ предполагается в более продвинутых функциях (хотя может быть сложнее и нет ничего)
 */
	effectMin =-1*effectMin
	// посмотреть составляющие компоненты образа действия ActionsImage: ActID и PhraseID
	//actImg,ok:=ActionsImageArr[actImgID]
	actImg,ok:=ReadeActionsImageArr(actImgID)
	if ok {
		dangerousVal:=getDangerousActionsImage(actImg)
		if dangerousVal < 0{
			effectMin += dangerousVal
		}
	}

	return effectMin
}

// определить опасность компонентов объекта типа ActionsImage
func getDangerousActionsImage(obj *ActionsImage)int {
	commonEffect:=0
	// проверяем массив действий
	if obj.ActID != nil {
		for i := 0; i < len(obj.ActID); i++ {
			iArr := getImportanceFromExtremImportance(obj.ActID[i], 3)
			if iArr != nil {
				commonEffect += (-prepForGetDangerousActionsImage(iArr))
			}
		}
	}
		// проверяем массив фраз
		if obj.PhraseID != nil {
			for i := 0; i < len(obj.PhraseID); i++ {
				iArr := getImportanceFromExtremImportance(obj.PhraseID[i], 5)
				if iArr != nil {
					commonEffect += (-prepForGetDangerousActionsImage(iArr))
				}
			}
		}
	// проверяем тон
	iArr := getImportanceFromExtremImportance(obj.ToneID, 7)
	if iArr != nil {
		commonEffect += (-prepForGetDangerousActionsImage(iArr))
	}
	// проверяем настроение
	iArr = getImportanceFromExtremImportance(obj.MoodID, 8)
	if iArr != nil {
		commonEffect += (-prepForGetDangerousActionsImage(iArr))
	}

	return commonEffect
}
/////////////////////////////////////////////////

// максимальная отрицательная значимость
func prepForGetDangerousActionsImage(iArr []*importance)int{
	max:=0
	for n := 0; n < len(iArr); n++ {
		if iArr[n].ProblemID != detectedActiveLastProblemNodID{
			continue
		}
		// м.б. учитывать для всех iArr[n].ProblemID  веток дерева проблем, а не только для текущей ветки?
		if iArr[n].Value < max{
			max=iArr[n].Value
		}
	}
	return max
}
/////////////////////////////////////////////////////////////////




